//-------------------------------------------STM32F4_DAC-------------------------------------------------------

/* Beschreibung:
 * Der DAC wird angesteuert und ein Spannungswert wird ausgegeben
 */
/*


Hinweis zum Clock fuer 8MHz Quarz, damit er auf 168MHz luft (betrifft das stm32F4Discovery):

in der system_stm32f4xx.c muss eingetragen sein:
PLL_M = 8

in der stm32f4xx.h muss eingetragen sein:
HSE_VALUE = 8000000
*/

#include <stdio.h>
#include <stdlib.h>

#include "stm32f4xx.h"
#include "stm32f4xx_gpio.h"
#include "stm32f4xx_rcc.h"
#include "misc.h"
#include "stm32f4xx_dac.h"


void Delay(__IO uint32_t nCount)
{
  while(nCount--)
  {
  }
}


void DAC_INIT_EXAMPLE(void)
{
/* Preconfiguration before using DAC----------------------------------------*/
  GPIO_InitTypeDef GPIO_InitStructure;
  DAC_InitTypeDef  DAC_InitStructure;

/* DAC Periph clock enable */
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);

/*(DAC_OUT2 = PA.5) configuration */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

/* DAC channel2 Configuration */
  DAC_InitStructure.DAC_Trigger = DAC_Trigger_None;
  DAC_InitStructure.DAC_WaveGeneration = DAC_WaveGeneration_None;
  DAC_InitStructure.DAC_OutputBuffer = DAC_OutputBuffer_Enable;
  DAC_Init(DAC_Channel_2, &DAC_InitStructure);

  DAC_SetChannel2Data(DAC_Align_12b_R,0); // Spannungswert 0V vorgeben
  DAC_Cmd(DAC_Channel_2, ENABLE);
}


int main(void)
{

	SystemInit();

	//initialisiert den DAC
	DAC_INIT_EXAMPLE();

	//setzt eine Spannung
	DAC_SetChannel2Data(DAC_Align_12b_R,1500);

	while(1)
    {

    }
}
